//
//  Operatoren.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

func operators() {
	assignmentOperator()
	arithmeticOperators()
	remainderOperator()
	unaryMinusOperator()
	compoundAssignmentOperators()
	comparisonOperators()
	terneryCondiationOperator()
	nilCoalescingOperator()
	rangeOperators()
	logicalOperators()
	incrementOperators()
}

func incrementOperators() {
	print(__FUNCTION__)

	var i = 0
	
	i = i + 1
	i += 1
	i++
	
	print(i++)
	print(i)
	
	i--
	print(i)
	print(i--)
	print(i)
	print(--i)
	print(i)
}

func logicalOperators() {
	print(__FUNCTION__)
	
	// NICHT	!
	// UND		&&
	// ODER		||
	
	let lampeAn = true
	let tuerOffen = false
	
	if lampeAn || tuerOffen {
		print("die Lampe ist an, oder die Tür ist offen")
	}
	
	if lampeAn && tuerOffen {
		print("Lampe ist an UND die Tür ist offen")
	}

	if lampeAn && !tuerOffen {
		print("Lampe ist an UND die Tür ist nicht offen")
	}
}

func rangeOperators() {
	print(__FUNCTION__)

	print("closed range operator")
	for i in 1...7 {
		print(i)
	}
	
	print("half open range operator")
	for i in 0..<5 {
		print(i)
	}
	
	let namen = ["franky", "willi", "peter", "claus"]
	print(namen[0])
	print(namen[1])
	print(namen[2])
	print(namen[3])
	
	for i in 0 ..< namen.count {
		print(namen[i])
	}
	
}

func nilCoalescingOperator() {
	print(__FUNCTION__)
	
	let wert = Int("textGehtNicht") ?? Int.min
	print(wert)
}

func terneryCondiationOperator() {
	print(__FUNCTION__)
	
	let lampeOn = Int("5")! == 4
	
	var statusString = ""
	if lampeOn {
		statusString = "an"
	} else {
		statusString = "aus"
	}
	print("Die Lampe ist \(statusString)")
	
	print("Die Lampe ist \(lampeOn ? "an" : "aus")")
}

func comparisonOperators() {
	print(__FUNCTION__)
	
	let a = 5
	let b = 7
	
	print(a == b)
	print(a != b)
	print(a > b)
	print(a < b)
	print(a >= b)
	print(a <= b)
	
	// === identity operator
	// !== "
	
}

func compoundAssignmentOperators() {
	print(__FUNCTION__)
	
	var a = 17
	a += 3		// a = a + 3
	a -= 1		// a = a - 1
	a *= 3		// ...
	a /= 2		// ...
	print(a)
}

func unaryMinusOperator() {
	print(__FUNCTION__)
	let value = 7
	let minusValue = -value
	let plusValue = -minusValue
	
	print(plusValue)
}

func remainderOperator() {
	print(__FUNCTION__)
	print (7 % 4)
	
	print(8 % 2.5)
}

//func +(lhs:Int, rhs:Int) -> Int { return lhs - rhs }
func arithmeticOperators() {
	print(__FUNCTION__)
	
	print(10 + 7)
	print(5 - 3)
	print(5 * 3)
	print(5.0 / 2.0)
	
	var kleinerWert:Int8 = 126
	
	kleinerWert = kleinerWert &+ Int8("2")!
	
	print(kleinerWert)
	
	let string1 = "hello"
	let string2 = "world"
	let welcome = string1 + ", " + string2 + "!"
	print(welcome)
}

func assignmentOperator() {
	print(__FUNCTION__)
	
	let b = 10
	var a = 5
	a = b
	
	let(x, y) = (1, 5)
	
	print("a = \(a)")
	print("x = \(x)")
	print("y = \(y)")
}