//
//  Seminar.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

class Haus {
	var mieter:Mieter?
}

class Mieter {
	var schluessel:Schluessel?
}

class Schluessel {
	var tuer:Tuer?
}

class Tuer {
	var name:String!
	
	func oeffnen() {
		print("hereinspaziert")
	}
}

func optionals() {
	let tuer = Tuer()
	tuer.name = "Haustür"
	
	let schluessel = Schluessel()
	let mieter = Mieter()
	let haus:Haus! = Haus()
	
	haus.mieter = mieter
	mieter.schluessel = schluessel
	schluessel.tuer = nil
	
	haus.mieter?.schluessel?.tuer = tuer
	haus.mieter?.schluessel?.tuer?.oeffnen()
	
	if let haus = haus {
		if let mieter = haus.mieter {
			if let schluessel = mieter.schluessel {
				if let tuer = schluessel.tuer {
					print("die Tür heißT: \(tuer.name)")
				}
			}
		}
	}
	
	if let haus = haus,
		mieter = haus.mieter,
		schluessel = mieter.schluessel,
		tuer = schluessel.tuer,
		name = tuer.name
	{
		print("name = \(name)")
	}
	
	
}

func sagMalHallo () {
	
	//"bb||!bb"
	
	let textfeld = "123"
	
//	var wert: Optional<Int> = Optional.None
//	wert = Optional.Some(42)

	var wert: Int!

	wert = Int(textfeld)
	
	print("oben: \(wert.dynamicType)")
	print("oben: \(wert)")
	
	//	if wert != nil {
	//		print(wert!)
	//	} else {
	//		print("Der Text \(textfeld) konnte nicht in eine Zahl gewandelt werden!")
	//	}

	if let wert = wert {
		print(wert * 2)
	} else {
		print("Der Text \(textfeld) konnte nicht in eine Zahl gewandelt werden!")
	}
	

}