//
//  Generics.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 20.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

/*
func vertausche(inout a: Int, inout b: Int) {
	let tmp = a
	a = b
	b = tmp
}

func vertausche(inout a: Double, inout b: Double) {
	let tmp = a
	a = b
	b = tmp
}

func vertausche(inout a: String, inout b: String) {
	let tmp = a
	a = b
	b = tmp
}
*/

func vertausche<T> (inout a: T, inout b: T) {
	let tmp = a
	a = b
	b = tmp
}

func generics() {
	var a = 10.2
	var b = 8.9

	print("a = \(a), b = \(b)")
	vertausche(&a, b: &b)
	print("a = \(a), b = \(b)")
	
}