//
//  Strings.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

func strings() {
	print(__FUNCTION__)
	
	var welcome = "welcome to swift"
	print(welcome)
	
	var message = String()
	
	if message.isEmpty {
		message = "hello"
	}
	
	message += ", world!👻"
	
	print(message)
	
	for character in message.characters {
		print(character)
	}
	
	
	let text = "Guten Tag!"
	print(text[text.startIndex])
	print(text[text.endIndex.predecessor()])
	print(text[text.startIndex.successor()])
	print(text[text.startIndex.advancedBy(7)])
	
	for index in text.characters.indices {
		print(text[index])
	}
	
	welcome = "hello"
	welcome.insert("!", atIndex: welcome.endIndex)
	print(welcome)
	
	welcome.insertContentsOf(" there".characters, at: welcome.endIndex.predecessor())
	print(welcome)
	
	welcome.removeAtIndex(welcome.endIndex.predecessor())
	print(welcome)
	
	let range = welcome.endIndex.advancedBy(-6) ..< welcome.endIndex
	welcome.removeRange(range)
	print(welcome)
	
	let nachricht = "Willi sagt: Swift ist toll"

	if nachricht.hasPrefix("Willi") {
		print("Da hat Willi recht")
	}
	
	if nachricht.hasSuffix("toll") {
		print("das hätten wir auch nicht anders erwartet")
	}
	
}